Bug 1469581 - [Docs][RFE][Director] Provide sample environments for custom roles
[Docs][RFE][Director] Provide sample environments for custom roles
Product: Red Hat OpenStack
Classification: Red Hat
Component: documentation (Show other bugs)
12.0 (Pike)
Unspecified Unspecified
medium Severity unspecified
: async
: 12.0 (Pike)
Assigned To: Dan Macpherson
Mikey Ariel
: Documentation, FutureFeature, Triaged
Depends On: 1386860 1500544
  Show dependency treegraph
Reported: 2017-07-11 10:08 EDT by Dan Macpherson
Modified: 2018-03-08 21:49 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Dan Macpherson 2017-07-11 10:08:38 EDT
We now have the ability to create custom roles, but we don't yet have any examples in the environments/ directory of tripleo-heat-templates. Some of the most common roles should be demonstrated with sample environments in the environments/ directory, such as Neutron networker, all-in-one controller, etc.
Additional info: I would like to craft sample NIC templates for some of the most common composable roles, but I think that makes sense only if we are also including sample environments to create those same roles.

This includes a bucnh of new features for composable roles. First a set of new NIC templates have been added. But the director now has the ability to generate the roles_data.yaml file based upon a subset of role templates
Comment 1 Lucy Bopf 2017-08-07 22:36:20 EDT
Assigning to Dan for review.
Comment 2 Dan Macpherson 2017-10-06 01:54:29 EDT
Hi Alex,

I've started working on docs for the new custom role management commands and the new "roles" directory. Here's a draft of what I've written so far:


I've also revised other content in this chapter to use the new roles_data generation method.

I've got some more work to do on this, but I just wanted to get some early feedback from you. What do you think of what I've written so far? Any suggestions for improvements?
Comment 4 Alex Schultz 2017-10-06 17:16:16 EDT
Hey Dan,  

https://review.openstack.org/#/c/476236/ was the docs change upstream for this. The docs look ok but there's a but more nuance to the controller as the first role.  You may want to see the tags section from the roles doc https://github.com/openstack/tripleo-heat-templates/tree/master/roles as that explains it better.

Additionally we have some sample environments under THT/environments/composable-roles/ that leverage the provided roles.
Comment 5 Dan Macpherson 2017-10-08 23:27:59 EDT
Just to confirm, are "primary" and "controller" the only tags used so far?
Comment 6 Dan Macpherson 2017-10-09 00:49:43 EDT
I've also refined the content and structure  along similar lines as the upstream content. I've tried to start from the beginning and say, this is what the roles_data file is, here's how you make a roles_data file, here are the parameters you use, he's how to create a brand new role, etc.

Have a look and let me know what you think:

Comment 7 Alex Schultz 2017-10-09 10:32:49 EDT
Yes 'primary' and 'controller' are the only tags so far. Prior to these tags existing, the first role in roles_data.yaml was always considered the 'controller' role when doing the deployment. So the end user can apply both these tags to a role and then the order no longer matters in the roles_data.yaml.  I think what you have in the docs captures the basics of this for operators. Thanks!
Comment 8 Dan Macpherson 2017-10-09 21:25:14 EDT
(In reply to Alex Schultz from comment #7)
> I think what you have in the docs captures the basics of
> this for operators. Thanks!

Is there anything else we should add? It's good to cover the basics, but maybe we can go beyond the basics?
Comment 9 Alex Schultz 2017-11-06 11:57:40 EST
I don't really have any additional information to add. We might want to mention that there is a set of services that should be included as defaults for a role but I'm afraid this would be a pain to ensure is correctly updated in the downstream docs every release. This is an item that I've seen needs improvement in our role definitions.
Comment 14 Dan Macpherson 2017-12-07 18:46:19 EST
Hi Alex,

I updated the list of default services:


How does it look? Is everything expected?
Comment 15 Alex Schultz 2017-12-12 16:25:36 EST
So one thing that is missing is details about the networks in custom role files. That's not necessarily specific to the role features (it's for composable networks) but is something that should be documented as I'm not sure we default to anything if not specified.  Other than that it looks OK
Comment 16 Lucy Bopf 2017-12-13 23:25:44 EST
The GA milestone has now passed. Moving this tracker to 'async'.

Note You need to log in before you can comment on or make changes to this bug.